import { Component, OnInit, ViewChild, ElementRef, HostListener } from '@angular/core';
import { ToastrManager } from 'ng6-toastr-notifications';
import { FormBuilder, FormGroup, FormControl, Validators, FormArray } from "@angular/forms";

import { ErpService } from '../../../_services/erp.service';
import { ExcelService } from '../../../_services/excel.service';
import { ViewStyleComponent } from '../../shared/view-style/view-style.component';

@Component({
  selector: 'app-list-erp',
  templateUrl: './list-erp.component.html',
  styleUrls: ['./list-erp.component.css']
})
export class ListErpComponent implements OnInit {
  @ViewChild(ViewStyleComponent, { static: true }) style: ViewStyleComponent;
  @ViewChild('closeBtn', { static: false }) closeBtn: ElementRef<HTMLElement>;
  @HostListener('document:keydown.escape', ['$event']) onKeydownHandler(event: KeyboardEvent) {
    this.closeBtn.nativeElement.click();
    this.submitted = false;
  }

  NewERPForm: FormGroup;
  filterForm: FormGroup;

  purchase_orders: [];
  erps: [];
  styles: [];
  erp_statuses: [];
  buyers: [];
  p: number = 1;
  submitted = false;
  userRole = '';
  userDesignation = '';
  colordata;

  constructor(private api: ErpService,
    private excelService: ExcelService,
    private toastr: ToastrManager,
    private fb: FormBuilder) { }

  ngOnInit() {
    this.filterForm = this.fb.group({
      erp_order: [1],
      erp_buyer: [""],
      erp_style: [""],
      erp_status: [""],
    });

    this.userRole = localStorage.getItem('userRole');
    this.userDesignation = localStorage.getItem('userDesignation');
    this.createNewErpForm();
    this.getFilteredErpListData();
    this.getRequiredInitialData();
  }

  getFilteredErpListData() {
    this.api.getFilteredErpListData(this.filterForm.value).subscribe(response => {
      this.erps = response;
    });
  }

  getRequiredInitialData() {
    this.api.getRequiredInitialData().subscribe(response => {
      this.purchase_orders = response.purchase_orders;
      this.erp_statuses = response.erp_statuses;
      this.styles = response.styles;
      this.buyers = response.buyers;
    });
  }

  createNewErpForm() {
    this.submitted = false;
    this.NewERPForm = this.fb.group({
      erp_title: [""],
      po_number: [1, [Validators.required]],
      style_number: ["", [Validators.required]],
      quantity: ["", [Validators.required]],
      rate: ["", [Validators.required]],
      wash_type: ["", [Validators.required]],
      currency: ["", [Validators.required]],
      sizing_type: ["", Validators.required],
      season: ["", [Validators.required]],
      payment_terms: ["", [Validators.required]],
      delivery_terms: ["", [Validators.required]],
      erp_status: [""],
      erp_id: [""],
      itemRows: this.fb.array([this.initItemRows()])
    });
    this.api.getAutoGeneratedErpNumber().subscribe(response => {
      this.NewERPForm.patchValue({
        erp_title: response
      });
    });
  }
  get formArr() {
    return this.NewERPForm.get('itemRows') as FormArray;
  }
  initItemRows() {
    return this.fb.group({
      color_code: ['', [Validators.required]],
      color: ['', [Validators.required]],
      color_quantity: ['', [Validators.required]],

    });
  }

  keyup(event) {
    this.formArr.push(this.initItemRows());   
  }


  deleteRow(index: number) {
    this.formArr.removeAt(index);
  }


  editErp(data) {

    this.api.getColorData(data.erp_id).subscribe(response => {
      this.colordata = response;  

      this.submitted = false;
      this.NewERPForm = this.fb.group({
        erp_title: [data.erp_title],
        po_number: [data.po_number, [Validators.required]],
        style_number: [data.style_number, [Validators.required]],
        quantity: [data.quantity, [Validators.required]],
        rate: [data.rate, [Validators.required]],
        wash_type: [data.wash_type, [Validators.required]],
        currency: [data.currency, [Validators.required]],
        sizing_type: [data.sizing_type, Validators.required],
        season: [data.season, [Validators.required]],
        payment_terms: [data.payment_terms, [Validators.required]],
        delivery_terms: [data.delivery_terms, [Validators.required]],
        erp_status: [data.erp_status, [Validators.required]],
        erp_id: [data.erp_id],
        itemRows: this.fb.array([this.initItemRows()])
      });

      this.NewERPForm.setControl('itemRows', this.setExixtingColorData(this.colordata));
    });


  }
  setExixtingColorData(colordata): FormArray {
    const formArray = new FormArray([]);
    colordata.forEach(s => {
      formArray.push(this.fb.group({
        color_code: [s.color_code, [Validators.required]],
        color: [s.color, [Validators.required]],
        color_quantity: [s.quantity, [Validators.required]],
      }));
    });
    return formArray;
  }

  resetFilters() {
    this.filterForm.reset();
    this.getFilteredErpListData();
  }

  addorEditErp() {
    this.submitted = true;
    if (this.NewERPForm.invalid) {
      return;
    }
    this.api.addorEditErp(this.NewERPForm.value).subscribe(response => {
      if (response != 0) {
        if (this.NewERPForm.value.erp_id != '') {
          this.toastr.successToastr("ERP Updated successfully.");
        } else {
          this.toastr.successToastr("New ERP Generated successfully.")
        }
        this.closeBtn.nativeElement.click();
        this.getFilteredErpListData();
      } else {
        this.toastr.successToastr("Error! While generating ERP");
      }
    });
  }

  viewStyle(style_id) {
    this.style.showStyleDetails(style_id);
  }

  get formControls() {
    return this.NewERPForm.controls;
  }

  generateExcel() {
    let title = 'ERP Report';
    let header = ['ERP Id', 'Erp Title', 'PO Number', 'Style Name', 'Buyer', 'Quantity', 'Rate', 'Currency', 'Sizing Type', 
    'Delivery Terms', 'Payment Terms','Season', 'Wash Type', 'Erp Status','Created By', 'Created On'];
    let data = this.erps
    var result = [];
    Object.keys(data).forEach(function(key)
 {
      let data_row = [];
      data_row.push(data[key]["erp_id"]);
      data_row.push(data[key]["erp_title"]);
      data_row.push(data[key]["po_number"]);
      data_row.push(data[key]["style_name"]);
      data_row.push(data[key]["buyer"]);
      data_row.push(data[key]["quantity"]);
      data_row.push(data[key]["rate"]);
      data_row.push(data[key]["currency"]);
      data_row.push(data[key]["sizing_type"]);
      data_row.push(data[key]["delivery_terms"]);
      data_row.push(data[key]["payment_terms"]);
      data_row.push(data[key]["season"]);
      data_row.push(data[key]["wash_type"]);
      data_row.push(data[key]["status"]);
      
      data_row.push(data[key]["created_by_name"]);
      data_row.push(data[key]["created_on"]);
     

      result.push(data_row);
    });
    this.excelService.generateExcel(title, header, result);
  }
}
